#!/bin/bash
echo "==================================================================================================="
echo ""
echo "####################################### sudo4backitup ###########################################"
echo ""
echo "==================================================================================================="
read -p "Please enter Username for your iobroker Install (Enter for default: iobroker): " name
name=${name:-iobroker}

SUDOERS_FILE="/etc/sudoers.d/${name}"

echo "${name} ALL=(ALL) NOPASSWD: `which mount`
${name} ALL=(ALL) NOPASSWD: `which umount`
${name} ALL=(ALL) NOPASSWD: `which systemctl` start
${name} ALL=(ALL) NOPASSWD: `which systemctl` stop
${name} ALL=(ALL) NOPASSWD: `which shutdown` -h now
${name} ALL=(ALL) NOPASSWD: `which halt`
${name} ALL=(ALL) NOPASSWD: `which poweroff`
${name} ALL=(ALL) NOPASSWD: `which reboot`
${name} ALL=(ALL) NOPASSWD: `which apt-get`
${name} ALL=(ALL) NOPASSWD: `which apt`
${name} ALL=(ALL) NOPASSWD: `which dpkg`
${name} ALL=(ALL) NOPASSWD: `which make`
${name} ALL=(ALL) NOPASSWD: `which ping`
${name} ALL=(ALL) NOPASSWD: `which fping`
${name} ALL=(ALL) NOPASSWD: `which systemd-run`
${name} ALL=(ALL) NOPASSWD: `which arp-scan`
${name} ALL=(ALL) NOPASSWD: `which setcap`
ALL ALL=(${name}) NOPASSWD: `which node` /opt/iobroker/node_modules/iobroker.js-controller/iobroker.js" > ./temp_sudo_file

sudo visudo -c -q -f ./temp_sudo_file && \
    sudo chown root:root ./temp_sudo_file && \
    sudo chmod 440 ./temp_sudo_file && \
    sudo mv ./temp_sudo_file $SUDOERS_FILE
    
sudo usermod -a -G redis iobroker

echo "====================================================================================================================="
echo "################################# sudo4backitup finsh ... Please reboot now!! #######################################"
echo "====================================================================================================================="